'$dynamic

CLS

TYPE objdata
  animation_flags AS _UNSIGNED INTEGER
  start_animation_frame_index AS _UNSIGNED _BYTE
  end_animation_frame_index AS _UNSIGNED _BYTE
  width AS _UNSIGNED _BYTE
  height AS _UNSIGNED _BYTE
  animation_frame_data_size AS _UNSIGNED INTEGER
  mask_offset_from_image AS _UNSIGNED INTEGER
  unknown1 AS _UNSIGNED INTEGER
  unknown2 AS _UNSIGNED INTEGER
  trigger_left AS _UNSIGNED INTEGER
  trigger_top AS _UNSIGNED INTEGER
  trigger_width AS _UNSIGNED _BYTE
  trigger_height AS _UNSIGNED _BYTE
  trigger_effect_id AS _UNSIGNED _BYTE
  animation_frames_base_loc AS _UNSIGNED INTEGER
  preview_image_index AS _UNSIGNED INTEGER
  unknown3 AS _UNSIGNED INTEGER
  trap_sound_effect_id AS _UNSIGNED _BYTE
END TYPE

TYPE objlemminidata
  frames AS _UNSIGNED INTEGER
  anim AS _UNSIGNED INTEGER
  effect AS _UNSIGNED INTEGER
  soundfx AS _UNSIGNED INTEGER
END TYPE

TYPE terdata
  width AS _UNSIGNED _BYTE
  height AS _UNSIGNED _BYTE
  image_loc AS _UNSIGNED INTEGER
  mask_loc AS _UNSIGNED INTEGER
  unknown1 AS _UNSIGNED INTEGER
END TYPE

TYPE pallent
  red AS _UNSIGNED _BYTE
  green AS _UNSIGNED _BYTE
  blue AS _UNSIGNED _BYTE
END TYPE

DIM ObjectData(15) AS objdata
DIM ObjectLemminiData(15) AS objlemminidata
DIM TerrainData(63) AS terdata
DIM SHARED defpal(7) AS pallent
DIM SHARED custpal(7) AS pallent
DIM SHARED blankpal(15) AS pallent
DIM temppall AS pallent
FOR x = 0 TO 15
  IF x < 8 THEN
    defpal(x).red = 0
    defpal(x).green = 0
    defpal(x).blue = 0
    custpal(x).red = 0
    custpal(x).green = 0
    custpal(x).blue = 0
  END IF
  blankpal(x).red = 0
  blankpal(x).green = 0
  blankpal(x).blue = 0
NEXT
defpal(1).red = 64
defpal(1).green = 64
defpal(1).blue = 224
defpal(2).green = 176
defpal(3).red = 240
defpal(3).green = 208
defpal(3).blue = 208
defpal(4).red = 176
defpal(4).green = 176
defpal(5).red = 240
defpal(5).green = 32
defpal(5).blue = 32
defpal(6).red = 128
defpal(6).green = 128
defpal(6).blue = 128
blankpal(1).red = 255
blankpal(1).blue = 255

DIM SHARED image(0) AS _UNSIGNED _BYTE

DATA "dirt","fire","marble","pillar","crystal"
DATA "brick","rock","snow","bubble","xmas"

DIM stylename$(9)
FOR loadstys = 0 TO 9
  READ stylename$(loadstys)
NEXT

DATA 0,8,0,0,6,5,7,4,3,0
DIM fxredir(30)
FOR loadredir = 0 TO 9
  READ fxredir(loadredir)
NEXT

DATA 11,20,19,20,1,16,16,-1,6,6,20,1,15,16,16,20,6,19
DIM sndredir(30)
FOR q = 0 TO 17
  READ sndredir(q)
NEXT
rssnd = 0

DIM existing(9)

IF _FILEEXISTS("dlgxconf.txt") THEN
  OPEN "dlgxconf.txt" FOR INPUT AS 1
  FOR kl = 0 TO 9
    INPUT #1, stylename$(kl)
  NEXT
  CLOSE 1
ELSE
  OPEN "dlgxconf.txt" FOR OUTPUT AS 1
  FOR kl = 0 TO 9
    WRITE #1, stylename$(kl)
  NEXT
  CLOSE 1
END IF
 
FOR checkexist = 0 TO 9
  tick = 0
  IF _FILEEXISTS("ground" + num$(checkexist) + "o.dat") THEN tick = tick + 1
  IF _FILEEXISTS("vgagr" + num$(checkexist) + ".dat.0") THEN tick = tick + 1
  IF _FILEEXISTS("vgagr" + num$(checkexist) + ".dat.1") THEN tick = tick + 1
  IF tick = 3 THEN existing(checkexist) = 1
NEXT


   

PRINT "DOS Lemmings Graphic Extractor"
PRINT "by Namida Verasche"
PRINT
PRINT "Please ensure you have placed the following files in"
PRINT "the same folder as this app:"
PRINT
PRINT "GROUNDxO.DAT          Graphic Sets Found:"
PRINT "VGAGRx.DAT.0"
PRINT "VGAGRx.DAT.1"

FOR outgfx = 0 TO 4
  LOCATE (8 + outgfx), 25
  IF existing(outgfx) = 1 THEN PRINT outgfx; " - "; LEFT$(stylename$(outgfx), 8)
NEXT

FOR outgfx = 5 TO 9
  LOCATE (3 + outgfx), 38
  IF existing(outgfx) = 1 THEN PRINT outgfx; " - "; LEFT$(stylename$(outgfx), 8)
NEXT


FOR handlefile = 0 TO 9
  grfile$ = "ground" + num$(handlefile) + "o.dat"
  vgfile$ = "vgagr" + num$(handlefile) + ".dat.0"
  vgfile2$ = "vgagr" + num$(handlefile) + ".dat.1"
  IF _FILEEXISTS(grfile$) AND _FILEEXISTS(vgfile$) AND _FILEEXISTS(vgfile2$) THEN
    LOCATE 13, 1
    PRINT "                                                 "
    LOCATE 13, 1
    PRINT "[ Currently processing: "; stylename$(handlefile); " ]"
    OPEN grfile$ FOR BINARY AS 1
    OPEN vgfile$ FOR BINARY AS 2
    OPEN vgfile2$ FOR BINARY AS 3
    IF _DIREXISTS(stylename$(handlefile)) = false THEN MKDIR stylename$(handlefile)
    LOCATE 14, 1
    PRINT "                                   "
    LOCATE 14, 1
    PRINT "Loading pallete..."
    GET 1, 985, custpal()
    FOR cpadj = 0 TO 7
      custpal(cpadj).red = custpal(cpadj).red * 4
      custpal(cpadj).green = custpal(cpadj).green * 4
      custpal(cpadj).blue = custpal(cpadj).blue * 4
    NEXT
    
    LOCATE 14, 1
    PRINT "                                  "
    LOCATE 14, 1
    PRINT "Loading object and terrain info..."
    
    GET 1, 1, ObjectData()
    GET 1, 449, TerrainData()
    
    LOCATE 14, 1
    PRINT "                                      "
    LOCATE 14, 1
    
    PRINT "Extracting terrain graphics..."
 
    FOR decodeterrain = 0 TO 63
      tilcount = decodeterrain
      LOCATE 15, 1
      PRINT "                                     "
      LOCATE 15, 1
      PRINT "Extracting piece: "; decodeterrain
      imgwidth = TerrainData(decodeterrain).width
      imgheight = TerrainData(decodeterrain).height
      IF imgwidth = 0 OR imgheight = 0 THEN EXIT FOR
      imgloc = TerrainData(decodeterrain).image_loc
      mskloc = TerrainData(decodeterrain).mask_loc
      LOCATE 16, 1
      PRINT "                                     "
      LOCATE 16, 1
      PRINT "Loading image..."
      REDIM image(imgwidth * imgheight) AS _UNSIGNED _BYTE
      DecodeGraphic image(), 0, imgwidth, imgheight, imgloc, mskloc
      LOCATE 16, 1
      PRINT "                                     "
      LOCATE 16, 1
      PRINT "Saving image to file..."
      'fname$ = stylename$(handlefile) + "\" +stylename$(handlefile) + "_" + num$(decodeterrain) + "_S.gif"
      'makegiffromimage fname$, image(), imgwidth, imgheight, 0
      fname$ = stylename$(handlefile) + "\" + stylename$(handlefile) + "_" + num$(decodeterrain) + ".gif"
      makegiffromimage fname$, image(), imgwidth, imgheight, 1
    NEXT
    LOCATE 15, 1
    PRINT "                                     "
    LOCATE 16, 1
    PRINT "                                     "
    LOCATE 14, 1
    PRINT "                                     "
    LOCATE 14, 1
    PRINT "Extracting object graphics..."
    FOR dob = 0 TO 15
      objcount = dob
      LOCATE 15, 1
      PRINT "                                     "
      LOCATE 15, 1
      PRINT "Extracting piece: "; dob
      imgwidth = ObjectData(dob).width
      imgheight = ObjectData(dob).height
      IF imgwidth = 0 OR imgheight = 0 THEN EXIT FOR
      size = imgwidth * imgheight
      imgloc = ObjectData(dob).animation_frames_base_loc
      interval = ObjectData(dob).animation_frame_data_size
      frames = ObjectData(dob).end_animation_frame_index
      maskoff = ObjectData(dob).mask_offset_from_image
      ttop = (ObjectData(dob).trigger_top) * 4 - 4
      tleft = (ObjectData(dob).trigger_left) * 4
      tbot = (ObjectData(dob).trigger_height * 4) + ttop - 1
      tright = (ObjectData(dob).trigger_width * 4) + tleft - 1
	  effwdt = imgwidth
	  effhgt = imgheight
      'effwdt = max(imgwidth, tright + 1)
      'effhgt = max(imgheight, tbot + 1)
      REDIM simage(effwdt * effhgt * (frames + 1)) AS _UNSIGNED _BYTE
	  for setclear = 0 to ((effwdt * effhgt * (frames + 1)) - 1)
	    simage(setclear) = 16
	  next
      REDIM tframe(imgwidth * imgheight) AS _UNSIGNED _BYTE
      effsize = effwdt * effhgt
      LOCATE 16, 1
      PRINT "                                     "
      LOCATE 16, 1
      PRINT "Loading images..."
      FOR fr = 0 TO (frames - 1)
        REDIM image(imgwidth * imgheight) AS _UNSIGNED _BYTE
        DecodeGraphic image(), 1, imgwidth, imgheight, imgloc, maskoff
        IF dob = 1 THEN
          IF fr = 0 THEN
            FOR q = 0 TO (size - 1)
              tframe(q) = image(q)
            NEXT
          ELSE
            FOR apy = 0 TO imgheight - 1
              FOR apx = 0 TO imgwidth - 1
                simage((effwdt * effhgt * (fr - 1)) + (apy * effwdt) + apx) = image((apy * imgwidth) + apx)
              NEXT
            NEXT
          END IF
        ELSE
          FOR apy = 0 TO imgheight - 1
            FOR apx = 0 TO imgwidth - 1
              simage((effwdt * effhgt * (fr)) + (apy * effwdt) + apx) = image((apy * imgwidth) + apx)
            NEXT
          NEXT
        END IF
        imgloc = imgloc + interval
      NEXT
      IF dob = 1 THEN
        FOR apy = 0 TO imgheight - 1
          FOR apx = 0 TO imgwidth - 1
            simage((effwdt * effhgt * (frames - 1)) + (apy * effwdt) + apx) = tframe((apy * imgwidth) + apx)
          NEXT
        NEXT
      END IF
      LOCATE 16, 1
      PRINT "                                     "
      LOCATE 16, 1
      PRINT "Saving image to file..."
      'fname$ = stylename$(handlefile) + "\" + stylename$(handlefile) + "o_" + num$(dob) + "_S.gif"
      'makegiffromimage fname$, simage(), effwdt, effhgt, 0
      fname$ = stylename$(handlefile) + "\" + stylename$(handlefile) + "o_" + num$(dob) + ".gif"
      makegiffromimage fname$, simage(), effwdt, (effhgt * frames), 1
      IF ObjectData(dob).trigger_effect_id <> 0 THEN
        LOCATE 16, 1
        PRINT "                                     "
        LOCATE 16, 1
        PRINT "Generating trigger image..."
		effwdt = max(imgwidth, tright + 1)
        effhgt = max(imgheight, tbot + 1)
        REDIM image(effwdt * effhgt) AS _UNSIGNED _BYTE
        FOR dy = 0 TO effhgt - 1
          FOR dx = 0 TO effwdt - 1
            image((dy * effwdt) + dx) = 1
            IF dx < tleft THEN image((dy * effwdt) + dx) = 16
            IF dx > tright THEN image((dy * effwdt) + dx) = 16
            IF dy < ttop THEN image((dy * effwdt) + dx) = 16
            IF dy > tbot THEN image((dy * effwdt) + dx) = 16
          NEXT
        NEXT
        LOCATE 16, 1
        PRINT "                                     "
        LOCATE 16, 1
        PRINT "Saving image to file..."
        'fname$ = stylename$(handlefile) + "\" + stylename$(handlefile) + "om_" + num$(dob) + "_S.gif"
        'makegiffromimage fname$, image(), imgwidth, imgheight, 0
        fname$ = stylename$(handlefile) + "\" + stylename$(handlefile) + "om_" + num$(dob) + ".gif"
        makegiffromimage fname$, image(), imgwidth, imgheight, 1
      END IF
    NEXT
    LOCATE 15, 1
    PRINT "                                     "
    LOCATE 16, 1
    PRINT "                                     "
    LOCATE 14, 1
    PRINT "                                     "
    LOCATE 14, 1
    PRINT "Generating style INI file..."
    nl$ = stylename$(handlefile) + "\" + stylename$(handlefile) + ".ini"
    OPEN nl$ FOR BINARY AS 6
    writeini 6, "bgColor", "0x000033"
    putval$ = "0x" + hexbyte$(custpal(0).red) + hexbyte$(custpal(0).green) + hexbyte$(custpal(0).blue)
    writeini 6, "debrisColor", putval$
    putval$ = ""
    FOR palcol = 0 TO 15
      IF palcol < 8 THEN temppall = defpal(palcol)
      IF palcol > 7 THEN temppall = custpal(palcol - 8)
      putval$ = putval$ + "0x" + hexbyte$(temppall.red) + hexbyte$(temppall.green) + hexbyte$(temppall.blue)
      IF palcol < 15 THEN putval$ = putval$ + ","
    NEXT
    writeini 6, "particleColor", putval$
    writeini 6, "tiles", num$(tilcount)
    FOR doobj = 0 TO (objcount - 1)
      kt = ObjectData(doobj).end_animation_frame_index
      putval$ = num$(kt)
      writeini 6, "frames_" + num$(doobj), putval$
      atype = 1
      IF ObjectData(doobj).animation_flags AND 32768 THEN atype = 2
      IF kt = 1 THEN atype = 0
      IF doobj = 1 THEN atype = 3
      putval$ = num$(atype)
      writeini 6, "anim_" + num$(doobj), putval$
      putval$ = num$(fxredir(ObjectData(doobj).trigger_effect_id))
      IF doobj = 1 THEN putval$ = "32"
      writeini 6, "type_" + num$(doobj), putval$
      putval$ = "-2"
      ftt = ObjectData(doobj).trigger_effect_id
      fts = ObjectData(doobj).trap_sound_effect_id
      IF fts = 0 THEN putval$ = "-1"
      IF ftt = 1 THEN putval$ = "14"
      IF doobj = 1 THEN putval$ = "5"
      IF ftt = 5 THEN putval$ = "9"
      IF ftt = 6 THEN putval$ = "8"
      IF putval$ = "-2" THEN
        putval$ = num$(sndredir(rssnd) mod 30)
        rssnd = rssnd + 1
      END IF
      writeini 6, "sound_" + num$(doobj), putval$
    NEXT
    CLOSE 6
    LOCATE 14, 1
    PRINT "                                     "
    LOCATE 14, 1
    PRINT "Closing files..."
    CLOSE 1
    CLOSE 2
    CLOSE 3
    LOCATE 14, 1
    PRINT "                                     "
    LOCATE 14, 1
  END IF
NEXT

LOCATE 13, 1
PRINT "                                                 "
LOCATE 13, 1
PRINT "[ Finished! ]"

END

SUB makegiffromimage (fnm$, imgdata() AS _UNSIGNED _BYTE, width AS _UNSIGNED INTEGER, height AS _UNSIGNED INTEGER, doublesize)
OPEN fnm$ FOR BINARY AS 9
gifhead$ = "GIF89a"
PUT 9, 1, gifhead$

IF doublesize = 1 THEN
  width = width * 2
  height = height * 2
END IF

PUT 9, 7, width
PUT 9, 9, height
DIM tempbyte AS _UNSIGNED _BYTE
DIM tempint AS _UNSIGNED INTEGER
tempbyte = 244
PUT 9, 11, tempbyte
tempbyte = 0
PUT 9, 12, tempbyte
PUT 9, 13, tempbyte

defpal(7) = custpal(0)
PUT 9, 14, defpal()
PUT 9, 38, custpal()
PUT 9, 62, blankpal()

posit = 110

tempbyte = 33
PUT 9, posit, tempbyte
tempbyte = 249
PUT 9, posit + 1, tempbyte
tempbyte = 4
PUT 9, posit + 2, tempbyte
tempbyte = 1
PUT 9, posit + 3, tempbyte
tempint = 0
PUT 9, posit + 4, tempint
tempbyte = 16
PUT 9, posit + 6, tempbyte
tempbyte = 0
PUT 9, posit + 7, tempbyte
  
  
tempbyte = 44
PUT 9, posit + 8, tempbyte
tempint = 0
PUT 9, posit + 9, tempint
PUT 9, posit + 11, tempint
PUT 9, posit + 13, width
PUT 9, posit + 15, height
tempbyte = 0
PUT 9, posit + 17, tempbyte
  
tempbyte = 7
PUT 9, posit + 18, tempbyte
posit = posit + 19
bcnt = 0
  
css = 0
DIM codestream(0) AS _UNSIGNED _BYTE
codestream(0) = 128

kwidth = width
kheight = height
IF doublesize = 1 THEN
  kwidth = kwidth / 2
  kheight = kheight / 2
END IF
  
FOR yp = 0 TO (kheight - 1)
  FOR da = 0 TO 1
    FOR xp = 0 TO (kwidth - 1)
      FOR db = 0 TO 1
        nb = imgdata(xp + (yp * kwidth))
        css = css + 1
        REDIM _PRESERVE codestream(css) AS _UNSIGNED _BYTE
        codestream(css) = nb

        IF css MOD 120 = 0 THEN
          css = css + 1
          REDIM _PRESERVE codestream(css) AS _UNSIGNED _BYTE
          codestream(css) = 128
        END IF

        IF doublesize = 0 THEN EXIT FOR
      NEXT
    NEXT
    IF doublesize = 0 THEN EXIT FOR
  NEXT
NEXT
  
css = css + 1
REDIM _PRESERVE codestream(css) AS _UNSIGNED _BYTE
codestream(css) = 129
  
kpos = posit
FOR pf = 0 TO css
  IF pf MOD 254 = 0 THEN
    tempbyte = 254
    PUT 9, posit, tempbyte
    kpos = posit
    posit = posit + 1
  END IF
  PUT 9, posit, codestream(pf)
  posit = posit + 1
NEXT
  
tempbyte = (css MOD 254) + 1
PUT 9, kpos, tempbyte
tempbyte = 0
PUT 9, posit, tempbyte
posit = posit + 1
  
CLOSE 9
  
END SUB

SUB DecodeGraphic (outdata() AS _UNSIGNED _BYTE, isobject AS _BYTE, width AS _UNSIGNED _BYTE, height AS _UNSIGNED _BYTE, imgloc AS _UNSIGNED INTEGER, mskloc AS _UNSIGNED INTEGER)

IF isobject = 0 THEN
  fnum = 2
  msklc = mskloc
ELSE
  fnum = 3
  msklc = mskloc + imgloc
END IF


size = width * height

REDIM outdata(size) AS _UNSIGNED _BYTE
DIM inidata(size / 2) AS _UNSIGNED _BYTE
DIM inmdata(size / 8) AS _UNSIGNED _BYTE

GET fnum, imgloc + 1, inidata()
GET fnum, msklc + 1, inmdata()

ptt = 0
ptt2 = 0
  
FOR sect = 0 TO 3
  ptt2 = 0
  FOR pxl = 0 TO (size / 8) - 1
    FOR bit = 0 TO 7
      IF inidata(ptt) AND 2 ^ (7 - bit) THEN outdata(ptt2) = outdata(ptt2) + 2 ^ sect
      IF (inmdata(INT(ptt2 / 8)) AND 2 ^ (7 - bit)) = 0 THEN outdata(ptt2) = 16
      ptt2 = ptt2 + 1
    NEXT
    ptt = ptt + 1
  NEXT
NEXT

END SUB

FUNCTION num$ (innum)
a$ = STR$(innum)
WHILE LEFT$(a$, 1) = " "
  a$ = RIGHT$(a$, LEN(a$) - 1)
WEND
WHILE RIGHT$(a$, 1) = " "
  a$ = LEFT$(a$, LEN(a$) - 1)
WEND
num$ = a$
END FUNCTION

FUNCTION max (value1, value2)
a = value1
IF value2 > value1 THEN a = value2
max = a
END FUNCTION

FUNCTION min (value1, value2)
a = value1
IF value2 < value1 THEN a = value2
min = a
END FUNCTION

SUB writeini (fnum, skey$, value$)
posit = LOF(fnum) + 1
IF posit > 1 THEN
  DIM tempint AS _UNSIGNED INTEGER
  tempint = 2573
  PUT fnum, posit, tempint
  posit = posit + 2
END IF
kk$ = skey$ + " = " + value$
PUT fnum, posit, kk$
END SUB

FUNCTION hexbyte$ (number AS _UNSIGNED _BYTE)
q$ = HEX$(number)
IF LEN(q$) = 1 THEN q$ = "0" + q$
hexbyte$ = q$
END FUNCTION
